﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace MP3Player
{
    public partial class DockControl : GroupBox   
    {

        private Label _closeButton;
        int _oldWidth;

        public DockControl()
        {
            InitializeComponent();
            _closeButton = new Label();
            _closeButton.Text = "r";
            _closeButton.Font = new Font("Marlett",6f);
            _closeButton.Width = 16;
            _closeButton.Height = 16;
            _closeButton.TextAlign = ContentAlignment.MiddleRight;
            _closeButton.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            _closeButton.Padding = new Padding(0);
            _closeButton.FlatStyle = FlatStyle.Flat;
            _closeButton.MouseClick += new MouseEventHandler(OnCloseButtonClick);
            this.Controls.Add(_closeButton);
        }

        private void DockControl_DoubleClick(object sender, EventArgs e)
        {
            _oldWidth = Width;
            Width = 0;
        }

        protected override void OnControlAdded(ControlEventArgs e)
        {
            if (e.Control != _closeButton)
                e.Control.Dock = DockStyle.Fill;
            base.OnControlAdded(e);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            TextRenderer.DrawText(e.Graphics, Text, Font, new Point(0, 0), ForeColor);
        }

        private void OnCloseButtonClick(object sender, MouseEventArgs e)
        {
            _oldWidth = Width;
            Width = 0;
        }

        public void Expand()
        {
            Width = _oldWidth;
        }

        private void DockControl_Resize(object sender, EventArgs e)
        {
            if(Width != 0)
            _oldWidth = Width;
            _closeButton.Left = Width - _closeButton.Width;
        }
    }
}
