﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections;

namespace MP3Player
{
    class PlayList
    {
        BindingList<Song> _innerlist;

        public PlayList()
        {
            _innerlist = new BindingList<Song>();
        }

        public PlayList(IEnumerable<Song> collection)
        {
            _innerlist = new BindingList<Song>();
            foreach (Song item in collection)
            {
                _innerlist.Add(item);
            }
        }

        public BindingList<Song> InnerList
        {
            get {return _innerlist;}
        }

        public void AddSong(Song song)
        {
            _innerlist.Add(song);
        }

        public void AddSong(String song)
        {
            _innerlist.Add(new Song(song));
        }

        public void RemoveSong(int index)
        {
            _innerlist.RemoveAt(index);
        }

        public void Clear()
        {
            _innerlist.Clear();
        }

        public Song Item(int index)
        {
            return _innerlist.ElementAt(index);
        }

        public void RemoveSong(Song song)
        {
            _innerlist.Remove(song);
            _innerlist.OrderBy(s => s.GetHashCode());
        }

    }
}
